--[[
Copyright (c) 2011 Matthias Richter

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Except as contained in this notice, the name(s) of the above copyright holders
shall not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]--

--[[
Hardon Collider - Updated to work with Gideros by Cliff Earl, Antix software, Septemebr 2015.
--]]

AShape = Core.class()

local math_min, math_sqrt, math_huge = math.min, math.sqrt, math.huge

local vector  = require 'vector-light'
--local Polygon = require 'polygon'
local GJK     = require 'gjk' -- actual collision detection

function AShape:init(t)
	self._type = t
	self._rotation = 0
  
--  self.bbox={0,0,0,0} -- hmm
end

--function AShape:bbox()
--end

--function AShape:move(x,y)
--end

function AShape:moveTo(x,y)
	local cx,cy = self:center()
	self:move(x - cx, y - cy)
end

function AShape:rotation()
	return self._rotation
end

function AShape:rotate(angle)
	self._rotation = self._rotation + angle
end

function AShape:setRotation(angle, x,y)
	return self:rotate(angle - self._rotation, x,y)
end




--[[
function AShape:unpack()
	return self.x,self.y,self.width,self.height
end

function AShape:bbox()
	return AShape.unpack(self)
end
--]]